// Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
// http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
// <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
// option. This file may not be copied, modified, or distributed
// except according to those terms.

//! Project members API endpoints.
//!
//! These endpoints are used for querying project members.

mod add;
mod all_member;
mod all_members;
mod edit;
mod member;
mod members;
mod remove;

pub use self::all_member::AllProjectMember;
pub use self::all_member::AllProjectMemberBuilder;
pub use self::all_member::AllProjectMemberBuilderError;

pub use self::all_members::AllProjectMembers;
pub use self::all_members::AllProjectMembersBuilder;
pub use self::all_members::AllProjectMembersBuilderError;
pub use self::all_members::ProjectMemberState;

pub use self::add::AddProjectMember;
pub use self::add::AddProjectMemberBuilder;
pub use self::add::AddProjectMemberBuilderError;
#[allow(deprecated)]
pub use self::add::ProjectInviteTasksToBeDone;

pub use self::edit::EditProjectMember;
pub use self::edit::EditProjectMemberBuilder;
pub use self::edit::EditProjectMemberBuilderError;

pub use self::member::ProjectMember;
pub use self::member::ProjectMemberBuilder;
pub use self::member::ProjectMemberBuilderError;

pub use self::members::ProjectMembers;
pub use self::members::ProjectMembersBuilder;
pub use self::members::ProjectMembersBuilderError;

pub use self::remove::RemoveProjectMember;
pub use self::remove::RemoveProjectMemberBuilder;
pub use self::remove::RemoveProjectMemberBuilderError;
